Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# Lamp::Ray Class Reference

レイ More...

`#include <Ray.h>`

List of all members.

## Public Member Functions
| Ray ()
| コンストラクタ
| Ray (const Vector3 &origin, const Vector3 &direction)
| コンストラクタ
| Ray (float originX, float originY, float originZ, float directionX, float directionY, float directionZ)
| コンストラクタ
| Ray (const float *const source)
| コンストラクタ
void | set (const Vector3 &origin, const Vector3 &direction)
| 値の設定
void | set (float originX, float originY, float originZ, float directionX, float directionY, float directionZ)
| 値の設定
void | set (const float *const source)
| 値の設定
void | setOrigin (const Vector3 &origin)
| 原点の設定
void | setDirection (const Vector3 &direction)
| 方向の設定
const Vector3 & | getOrigin () const
| 原点の取得
const Vector3 & | getDirection () const
| 方向の取得
bool | isZero () const
| ゼロレイかどうか
Ray | transform (const Matrix33 &matrix) const
| トランスフォーム
Ray | transform (const Matrix34 &matrix) const
| トランスフォーム
Ray | transform (const Matrix44 &matrix) const
| トランスフォーム
float | getDistance (const Vector3 &point) const
| 点距離
float | getSquaredDistance (const Vector3 &point) const
| 点距離の二乗
float | getDistance (const AxisAlignedBox &axisAlignedBox) const
| 軸沿いボックス距離
float | getSquaredDistance (const AxisAlignedBox &axisAlignedBox) const
| 軸沿いボックス距離の二乗
float | getDistance (const Capsule &capsule) const
| カプセル距離
float | getSquaredDistance (const Capsule &capsule) const
| カプセル距離の二乗
float | getDistance (const Cone &cone) const
| コーン距離
float | getSquaredDistance (const Cone &cone) const
| コーン距離の二乗
float | getDistance (const Line &line) const
| ライン距離
float | getSquaredDistance (const Line &line) const
| ライン距離の二乗
float | getDistance (const OrientedBox &orientedBox) const
| 指向性ボックス距離
float | getSquaredDistance (const OrientedBox &orientedBox) const
| 指向性ボックス距離の二乗
float | getDistance (const Plane &plane) const
| 平面距離
float | getSquaredDistance (const Plane &plane) const
| 平面距離の二乗
float | getDistance (const Ray &ray) const
| レイ距離
float | getSquaredDistance (const Ray &ray) const
| レイ距離の二乗
float | getDistance (const Segment &segment) const
| セグメント距離
float | getSquaredDistance (const Segment &segment) const
| セグメント距離の二乗
float | getDistance (const Sphere &sphere) const
| 球距離
float | getSquaredDistance (const Sphere &sphere) const
| 球距離の二乗
float | getDistance (const Triangle &triangle) const
| 三角距離
float | getSquaredDistance (const Triangle &triangle) const
| 三角距離の二乗
bool | intersect (const Vector3 &point, float range=Math::epsilon) const
| 点交差
bool | intersect (const AxisAlignedBox &axisAlignedBox) const
| 軸沿いボックス交差
bool | intersect (const Capsule &capsule) const
| カプセル交差
bool | intersect (const Cone &cone) const
| コーン交差
bool | intersect (const Line &line, float range=Math::epsilon) const
| ライン交差
bool | intersect (const OrientedBox &orientedBox) const
| 指向性ボックス交差
bool | intersect (const Plane &plane) const
| 平面交差
bool | intersect (const Ray &ray, float range=Math::epsilon) const
| レイ交差
bool | intersect (const Segment &segment, float range=Math::epsilon) const
| セグメント交差
bool | intersect (const Sphere &sphere) const
| 球交差
bool | intersect (const Triangle &triangle) const
| 三角交差
bool | operator== (const Ray &target) const
| レイが同じかどうか
bool | epsilonEquals (const Ray &target, float epsilon) const
| レイが同じかどうか
bool | operator!= (const Ray &target) const
| レイが同じでないかどうか
bool | notEpsilonEquals (const Ray &target, float epsilon) const
| レイが同じでないかどうか
String | toString () const
| 文字列化
## Static Public Attributes
const Ray | zero
| ゼロレイ

## Detailed Description

レイ

このクラスは継承しないで下さい。

Definition at line 51 of file Ray.h.

## Constructor & Destructor Documentation

Lamp::Ray::Ray | ( |  | ) | `[inline]`

| コンストラクタ このコンストラクタは初期値の設定を行わないため値は不定です。 Definition at line 67 of file Ray.h. Referenced by transform().

Lamp::Ray::Ray | ( | const Vector3 & | origin,
|  | const Vector3 & | direction
| ) | `[inline]`

  | コンストラクタ Parameters:
  origin | 原点の初期値
  direction | 方向の初期値
Definition at line 74 of file Ray.h.

Lamp::Ray::Ray | ( | float | originX,
|  | float | originY,
|  | float | originZ,
|  | float | directionX,
|  | float | directionY,
|  | float | directionZ
| ) | `[inline]`

  | コンストラクタ Parameters:
  originX | 原点Xの初期値
  originY | 原点Yの初期値
  originZ | 原点Zの初期値
  directionX | 方向Xの初期値
  directionY | 方向Yの初期値
  directionZ | 方向Zの初期値
Definition at line 87 of file Ray.h.

Lamp::Ray::Ray | ( | const float *const | source | ) | `[inline, explicit]`

  | コンストラクタ Parameters:
  source | 初期値配列
Definition at line 97 of file Ray.h.

## Member Function Documentation

bool Lamp::Ray::epsilonEquals | ( | const Ray & | target,
|  | float | epsilon
| ) | const`[inline]`

  | レイが同じかどうか Parameters:
  target | 比較するレイ
  epsilon | 誤差
Returns: 誤差の範囲内で同じ値であればtrueを返す Definition at line 513 of file Ray.h. References Assert, direction_, Lamp::Vector3::epsilonEquals(), and origin_.

const Vector3& Lamp::Ray::getDirection | ( |  | ) | const`[inline]`

| 方向の取得 Returns: 方向 Definition at line 167 of file Ray.h. Referenced by Lamp::PlaneIntersection::intersect(), Lamp::AxisAlignedBoxIntersection::intersect(), Lamp::RayDistance::squaredDistance(), and Lamp::LineDistance::squaredDistance().

float Lamp::Ray::getDistance | ( | const Triangle & | triangle | ) | const`[inline]`

  | 三角距離 Parameters:
  triangle | 距離判定する三角
Returns: 距離 Definition at line 389 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Sphere & | sphere | ) | const`[inline]`

  | 球距離 Parameters:
  sphere | 距離判定する球
Returns: 距離 Definition at line 372 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Segment & | segment | ) | const`[inline]`

  | セグメント距離 Parameters:
  segment | 距離判定するセグメント
Returns: 距離 Definition at line 355 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Ray & | ray | ) | const`[inline]`

  | レイ距離 Parameters:
  ray | 距離判定するレイ
Returns: 距離 Definition at line 338 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Plane & | plane | ) | const

  | 平面距離 Parameters:
  plane | 距離判定する平面
Returns: 距離 Definition at line 84 of file Ray.cpp.

float Lamp::Ray::getDistance | ( | const OrientedBox & | orientedBox | ) | const`[inline]`

  | 指向性ボックス距離 Parameters:
  orientedBox | 距離判定する指向性ボックス
Returns: 距離 Definition at line 303 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Line & | line | ) | const`[inline]`

  | ライン距離 Parameters:
  line | 距離判定するライン
Returns: 距離 Definition at line 286 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Cone & | cone | ) | const`[inline]`

  | コーン距離 Parameters:
  cone | 距離判定するコーン
Returns: 距離 Definition at line 269 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Capsule & | capsule | ) | const`[inline]`

  | カプセル距離 Parameters:
  capsule | 距離判定するカプセル
Returns: 距離 Definition at line 252 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const AxisAlignedBox & | axisAlignedBox | ) | const`[inline]`

  | 軸沿いボックス距離 Parameters:
  axisAlignedBox | 距離判定する軸沿いボックス
Returns: 距離 Definition at line 235 of file Ray.h. References getSquaredDistance().

float Lamp::Ray::getDistance | ( | const Vector3 & | point | ) | const`[inline]`

  | 点距離 Parameters:
  point | 距離判定する点
Returns: 距離 Definition at line 218 of file Ray.h. References getSquaredDistance(). Referenced by getSquaredDistance().

const Vector3& Lamp::Ray::getOrigin | ( |  | ) | const`[inline]`

| 原点の取得 Returns: 原点 Definition at line 161 of file Ray.h. Referenced by Lamp::PlaneIntersection::intersect(), Lamp::AxisAlignedBoxIntersection::intersect(), Lamp::RayDistance::squaredDistance(), and Lamp::LineDistance::squaredDistance().

float Lamp::Ray::getSquaredDistance | ( | const Triangle & | triangle | ) | const

  | 三角距離の二乗 Parameters:
  triangle | 距離判定する三角
Returns: 距離の二乗 Definition at line 104 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Sphere & | sphere | ) | const

  | 球距離の二乗 Parameters:
  sphere | 距離判定する球
Returns: 距離の二乗 Definition at line 99 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Segment & | segment | ) | const

  | セグメント距離の二乗 Parameters:
  segment | 距離判定するセグメント
Returns: 距離の二乗 Definition at line 94 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Ray & | ray | ) | const

  | レイ距離の二乗 Parameters:
  ray | 距離判定するレイ
Returns: 距離の二乗 Definition at line 89 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Plane & | plane | ) | const`[inline]`

  | 平面距離の二乗 Parameters:
  plane | 距離判定する平面
Returns: 距離の二乗 Definition at line 327 of file Ray.h. References getDistance().

float Lamp::Ray::getSquaredDistance | ( | const OrientedBox & | orientedBox | ) | const

  | 指向性ボックス距離の二乗 Parameters:
  orientedBox | 距離判定する指向性ボックス
Returns: 距離の二乗 Definition at line 79 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Line & | line | ) | const

  | ライン距離の二乗 Parameters:
  line | 距離判定するライン
Returns: 距離の二乗 Definition at line 74 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Cone & | cone | ) | const

  | コーン距離の二乗 Parameters:
  cone | 距離判定するコーン
Returns: 距離の二乗 Definition at line 69 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Capsule & | capsule | ) | const

  | カプセル距離の二乗 Parameters:
  capsule | 距離判定するカプセル
Returns: 距離の二乗 Definition at line 64 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const AxisAlignedBox & | axisAlignedBox | ) | const

  | 軸沿いボックス距離の二乗 Parameters:
  axisAlignedBox | 距離判定する軸沿いボックス
Returns: 距離の二乗 Definition at line 59 of file Ray.cpp.

float Lamp::Ray::getSquaredDistance | ( | const Vector3 & | point | ) | const

  | 点距離の二乗 Parameters:
  point | 距離判定する点
Returns: 距離の二乗 Definition at line 54 of file Ray.cpp. Referenced by getDistance(), and Lamp::RayIntersection::intersect().

bool Lamp::Ray::intersect | ( | const Triangle & | triangle | ) | const

  | 三角交差 Parameters:
  triangle | 交差判定する三角
Returns: 交差していればtrue Definition at line 161 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Sphere & | sphere | ) | const

  | 球交差 Parameters:
  sphere | 交差判定する球
Returns: 交差していればtrue Definition at line 156 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Segment & | segment,
|  | float | range = Math::epsilon
| ) | const

  | セグメント交差 Parameters:
  segment | 交差判定するセグメント
  range | 交差範囲
Returns: 交差していればtrue Definition at line 151 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Ray & | ray,
|  | float | range = Math::epsilon
| ) | const

  | レイ交差 Parameters:
  ray | 交差判定するレイ
  range | 交差範囲
Returns: 交差していればtrue Definition at line 146 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Plane & | plane | ) | const

  | 平面交差 Parameters:
  plane | 交差判定する平面
Returns: 交差していればtrue Definition at line 141 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const OrientedBox & | orientedBox | ) | const

  | 指向性ボックス交差 Parameters:
  orientedBox | 交差判定する指向性ボックス
Returns: 交差していればtrue Definition at line 136 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Line & | line,
|  | float | range = Math::epsilon
| ) | const

  | ライン交差 Parameters:
  line | 交差判定するライン
  range | 交差範囲
Returns: 交差していればtrue Definition at line 131 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Cone & | cone | ) | const

  | コーン交差 Parameters:
  cone | 交差判定するコーン
Returns: 交差していればtrue Definition at line 126 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Capsule & | capsule | ) | const

  | カプセル交差 Parameters:
  capsule | 交差判定するカプセル
Returns: 交差していればtrue Definition at line 121 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const AxisAlignedBox & | axisAlignedBox | ) | const

  | 軸沿いボックス交差 Parameters:
  axisAlignedBox | 交差判定する軸沿いボックス
Returns: 交差していればtrue Definition at line 116 of file Ray.cpp.

bool Lamp::Ray::intersect | ( | const Vector3 & | point,
|  | float | range = Math::epsilon
| ) | const

  | 点交差 Parameters:
  point | 交差判定する点
  range | 交差範囲
Returns: 交差していればtrue Definition at line 111 of file Ray.cpp.

bool Lamp::Ray::isZero | ( |  | ) | const`[inline]`

| ゼロレイかどうか Returns: ゼロレイならtrue Definition at line 176 of file Ray.h. References Lamp::Vector3::epsilonEquals().

bool Lamp::Ray::notEpsilonEquals | ( | const Ray & | target,
|  | float | epsilon
| ) | const`[inline]`

  | レイが同じでないかどうか Parameters:
  target | 比較するレイ
  epsilon | 誤差
Returns: 誤差の範囲内で同じでない値であればtrueを返す Definition at line 536 of file Ray.h. References Assert, direction_, Lamp::Vector3::notEpsilonEquals(), and origin_.

bool Lamp::Ray::operator!= | ( | const Ray & | target | ) | const`[inline]`

  | レイが同じでないかどうか Parameters:
  target | 比較するレイ
Returns: 同じでない値であればtrueを返す Definition at line 525 of file Ray.h. References direction_, and origin_.

bool Lamp::Ray::operator== | ( | const Ray & | target | ) | const`[inline]`

  | レイが同じかどうか Parameters:
  target | 比較するレイ
Returns: 同じ値であればtrueを返す Definition at line 502 of file Ray.h. References direction_, and origin_.

void Lamp::Ray::set | ( | const float *const | source | ) | `[inline]`

  | 値の設定 Parameters:
  source | 設定値配列
Definition at line 134 of file Ray.h. References Lamp::Vector3::set().

void Lamp::Ray::set | ( | float | originX,
|  | float | originY,
|  | float | originZ,
|  | float | directionX,
|  | float | directionY,
|  | float | directionZ
| ) | `[inline]`

  | 値の設定 Parameters:
  originX | 設定する原点X
  originY | 設定する原点Y
  originZ | 設定する原点Z
  directionX | 設定する方向X
  directionY | 設定する方向Y
  directionZ | 設定する方向Z
Definition at line 124 of file Ray.h. References Lamp::Vector3::set().

void Lamp::Ray::set | ( | const Vector3 & | origin,
|  | const Vector3 & | direction
| ) | `[inline]`

  | 値の設定 Parameters:
  origin | 設定する原点
  direction | 設定する方向
Definition at line 110 of file Ray.h.

void Lamp::Ray::setDirection | ( | const Vector3 & | direction | ) | `[inline]`

  | 方向の設定 Parameters:
  direction | 設定する方向
Definition at line 150 of file Ray.h.

void Lamp::Ray::setOrigin | ( | const Vector3 & | origin | ) | `[inline]`

  | 原点の設定 Parameters:
  origin | 設定する原点
Definition at line 144 of file Ray.h.

String Lamp::Ray::toString | ( |  | ) | const`[inline]`

| 文字列化 Returns: レイの文字列表記 Definition at line 550 of file Ray.h. References Lamp::String::format(), Lamp::Vector3::x, Lamp::Vector3::y, and Lamp::Vector3::z.

Ray Lamp::Ray::transform | ( | const Matrix44 & | matrix | ) | const`[inline]`

  | トランスフォーム Parameters:
  matrix | 乗算する行列
Returns: 変換後のレイ Definition at line 206 of file Ray.h. References Lamp::Matrix44::multiply33(), and Ray().

Ray Lamp::Ray::transform | ( | const Matrix34 & | matrix | ) | const`[inline]`

  | トランスフォーム Parameters:
  matrix | 乗算する行列
Returns: 変換後のレイ Definition at line 197 of file Ray.h. References Lamp::Matrix34::multiply33(), and Ray().

Ray Lamp::Ray::transform | ( | const Matrix33 & | matrix | ) | const`[inline]`

  | トランスフォーム Parameters:
  matrix | 乗算する行列
Returns: 変換後のレイ Definition at line 188 of file Ray.h. References Ray().

The documentation for this class was generated from the following files:

- Ray.h
- Ray.cpp